var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _classCallCheck2=_interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));var _createClass2=_interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _shelljs=_interopRequireDefault(require("shelljs"));

var _exec=require("../systemTools/exec");
var _common=require("../common");
var _fileutils=require("../systemTools/fileutils");var

BasePlatformSetup=function(){
function BasePlatformSetup(os,globalConfigPath){(0,_classCallCheck2.default)(this,BasePlatformSetup);
this.os=os;
this.globalConfigPath=globalConfigPath;
this.availableDownloader=null;
this.androidSdkURL='https://dl.google.com/android/repository/sdk-tools-linux-4333796.zip';
this.androidSdkDownloadLocation='~/sdk-tools-linux-4333796.zip';
this.androidSdkLocation='~/Android'.replace('~',process.env.HOME);
this.sdksToInstall='"build-tools;28.0.3" "emulator" "extras;android;m2repository" "extras;google;m2repository" "patcher;v4" "platform-tools" "platforms;android-28" "sources;android-28" "system-images;android-28;google_apis_playstore;x86" "tools"';
}(0,_createClass2.default)(BasePlatformSetup,[{key:"checkPrereqs",value:function checkPrereqs()

{
(0,_common.logInfo)("Platform "+this.os);
(0,_common.logInfo)('Checking if wget or curl is installed');
if((0,_exec.commandExistsSync)('wget')){
this.availableDownloader='wget';
}else if((0,_exec.commandExistsSync)('curl')){
this.availableDownloader='curl';
}
}},{key:"installPrereqs",value:function installPrereqs(){return _regenerator.default.async(function installPrereqs$(_context){while(1){switch(_context.prev=_context.next){case 0:return _context.abrupt("return",



true);case 1:case"end":return _context.stop();}}});}},{key:"downloadAndroidSdk",value:function downloadAndroidSdk(){var downloader,aditionalArguments,locationArgument,command;return _regenerator.default.async(function downloadAndroidSdk$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:



downloader=this.availableDownloader;if(
downloader){_context2.next=3;break;}throw new Error('Wget or cURL not installed!');case 3:_context2.next=5;return _regenerator.default.awrap(

_shelljs.default.exec("rm "+this.androidSdkDownloadLocation+" > /dev/null 2>&1"));case 5:



if(downloader==='wget'){
aditionalArguments='-q';
locationArgument='-P ~/';
}
if(downloader==='curl'){
aditionalArguments='-#';
locationArgument="--output "+this.androidSdkDownloadLocation;
}

command=downloader+" "+aditionalArguments+" "+this.androidSdkURL+" "+locationArgument;

(0,_common.logDebug)('BasePlatformSetup -> downloadAndroidSdk -> command',command);
(0,_common.logInfo)('Downloading Android SDK...');_context2.next=12;return _regenerator.default.awrap(
_shelljs.default.exec(command));case 12:case"end":return _context2.stop();}}},null,this);}},{key:"unzipAndroidSdk",value:function unzipAndroidSdk(){return _regenerator.default.async(function unzipAndroidSdk$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:if(



(0,_exec.commandExistsSync)('unzip')){_context3.next=2;break;}throw new Error('unzip is not installed');case 2:_context3.next=4;return _regenerator.default.awrap(
_shelljs.default.exec("unzip -qq -o "+this.androidSdkDownloadLocation+" -d "+this.androidSdkLocation));case 4:case"end":return _context3.stop();}}},null,this);}},{key:"installSdksAndEmulator",value:function installSdksAndEmulator(){return _regenerator.default.async(function installSdksAndEmulator$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:



(0,_common.logDebug)('BasePlatformSetup -> installSdksAndEmulator -> accepting licenses');_context4.next=3;return _regenerator.default.awrap(
_shelljs.default.exec("yes | "+this.androidSdkLocation+"/tools/bin/sdkmanager --licenses > /dev/null"));case 3:
(0,_common.logDebug)('BasePlatformSetup -> installSdksAndEmulator -> installing sdk',this.sdksToInstall);_context4.next=6;return _regenerator.default.awrap(
_shelljs.default.exec(this.androidSdkLocation+"/tools/bin/sdkmanager "+this.sdksToInstall+" > /dev/null"));case 6:case"end":return _context4.stop();}}},null,this);}},{key:"installAndroidSdk",value:function installAndroidSdk(){return _regenerator.default.async(function installAndroidSdk$(_context5){while(1){switch(_context5.prev=_context5.next){case 0:



this.checkPrereqs();_context5.next=3;return _regenerator.default.awrap(
this.installPrereqs());case 3:_context5.next=5;return _regenerator.default.awrap(
this.downloadAndroidSdk());case 5:_context5.next=7;return _regenerator.default.awrap(
this.unzipAndroidSdk());case 7:_context5.next=9;return _regenerator.default.awrap(
this.installSdksAndEmulator());case 9:_context5.next=11;return _regenerator.default.awrap(
(0,_fileutils.updateConfigFile)({androidSdk:this.androidSdkLocation},this.globalConfigPath));case 11:return _context5.abrupt("return",
this.androidSdkLocation);case 12:case"end":return _context5.stop();}}},null,this);}}]);return BasePlatformSetup;}();var _default=



BasePlatformSetup;exports.default=_default;